/* Auto-generated by genmsg_cpp for file /home/east/ros_workspace/TestNode/srv/PrintPerson.srv */
#ifndef TESTNODE_SERVICE_PRINTPERSON_H
#define TESTNODE_SERVICE_PRINTPERSON_H
#include <string>
#include <vector>
#include <map>
#include <ostream>
#include "ros/serialization.h"
#include "ros/builtin_message_traits.h"
#include "ros/message_operations.h"
#include "ros/time.h"

#include "ros/macros.h"

#include "ros/assert.h"

#include "ros/service_traits.h"

#include "TestNode/Person.h"


#include "TestNode/Person.h"

namespace TestNode
{
template <class ContainerAllocator>
struct PrintPersonRequest_ {
  typedef PrintPersonRequest_<ContainerAllocator> Type;

  PrintPersonRequest_()
  : person()
  {
  }

  PrintPersonRequest_(const ContainerAllocator& _alloc)
  : person(_alloc)
  {
  }

  typedef  ::TestNode::Person_<ContainerAllocator>  _person_type;
   ::TestNode::Person_<ContainerAllocator>  person;


  typedef boost::shared_ptr< ::TestNode::PrintPersonRequest_<ContainerAllocator> > Ptr;
  typedef boost::shared_ptr< ::TestNode::PrintPersonRequest_<ContainerAllocator>  const> ConstPtr;
  boost::shared_ptr<std::map<std::string, std::string> > __connection_header;
}; // struct PrintPersonRequest
typedef  ::TestNode::PrintPersonRequest_<std::allocator<void> > PrintPersonRequest;

typedef boost::shared_ptr< ::TestNode::PrintPersonRequest> PrintPersonRequestPtr;
typedef boost::shared_ptr< ::TestNode::PrintPersonRequest const> PrintPersonRequestConstPtr;


template <class ContainerAllocator>
struct PrintPersonResponse_ {
  typedef PrintPersonResponse_<ContainerAllocator> Type;

  PrintPersonResponse_()
  : result()
  {
  }

  PrintPersonResponse_(const ContainerAllocator& _alloc)
  : result(_alloc)
  {
  }

  typedef  ::TestNode::Person_<ContainerAllocator>  _result_type;
   ::TestNode::Person_<ContainerAllocator>  result;


  typedef boost::shared_ptr< ::TestNode::PrintPersonResponse_<ContainerAllocator> > Ptr;
  typedef boost::shared_ptr< ::TestNode::PrintPersonResponse_<ContainerAllocator>  const> ConstPtr;
  boost::shared_ptr<std::map<std::string, std::string> > __connection_header;
}; // struct PrintPersonResponse
typedef  ::TestNode::PrintPersonResponse_<std::allocator<void> > PrintPersonResponse;

typedef boost::shared_ptr< ::TestNode::PrintPersonResponse> PrintPersonResponsePtr;
typedef boost::shared_ptr< ::TestNode::PrintPersonResponse const> PrintPersonResponseConstPtr;

struct PrintPerson
{

typedef PrintPersonRequest Request;
typedef PrintPersonResponse Response;
Request request;
Response response;

typedef Request RequestType;
typedef Response ResponseType;
}; // struct PrintPerson
} // namespace TestNode

namespace ros
{
namespace message_traits
{
template<class ContainerAllocator> struct IsMessage< ::TestNode::PrintPersonRequest_<ContainerAllocator> > : public TrueType {};
template<class ContainerAllocator> struct IsMessage< ::TestNode::PrintPersonRequest_<ContainerAllocator>  const> : public TrueType {};
template<class ContainerAllocator>
struct MD5Sum< ::TestNode::PrintPersonRequest_<ContainerAllocator> > {
  static const char* value() 
  {
    return "a6e1d6d2e61347b1d6f27dd9a8b3b8ed";
  }

  static const char* value(const  ::TestNode::PrintPersonRequest_<ContainerAllocator> &) { return value(); } 
  static const uint64_t static_value1 = 0xa6e1d6d2e61347b1ULL;
  static const uint64_t static_value2 = 0xd6f27dd9a8b3b8edULL;
};

template<class ContainerAllocator>
struct DataType< ::TestNode::PrintPersonRequest_<ContainerAllocator> > {
  static const char* value() 
  {
    return "TestNode/PrintPersonRequest";
  }

  static const char* value(const  ::TestNode::PrintPersonRequest_<ContainerAllocator> &) { return value(); } 
};

template<class ContainerAllocator>
struct Definition< ::TestNode::PrintPersonRequest_<ContainerAllocator> > {
  static const char* value() 
  {
    return "TestNode/Person person\n\
\n\
================================================================================\n\
MSG: TestNode/Person\n\
string name\n\
int32 age\n\
float32 grade\n\
\n\
";
  }

  static const char* value(const  ::TestNode::PrintPersonRequest_<ContainerAllocator> &) { return value(); } 
};

} // namespace message_traits
} // namespace ros


namespace ros
{
namespace message_traits
{
template<class ContainerAllocator> struct IsMessage< ::TestNode::PrintPersonResponse_<ContainerAllocator> > : public TrueType {};
template<class ContainerAllocator> struct IsMessage< ::TestNode::PrintPersonResponse_<ContainerAllocator>  const> : public TrueType {};
template<class ContainerAllocator>
struct MD5Sum< ::TestNode::PrintPersonResponse_<ContainerAllocator> > {
  static const char* value() 
  {
    return "ce4ed7a01f8aa26d42c0728a5512d1e7";
  }

  static const char* value(const  ::TestNode::PrintPersonResponse_<ContainerAllocator> &) { return value(); } 
  static const uint64_t static_value1 = 0xce4ed7a01f8aa26dULL;
  static const uint64_t static_value2 = 0x42c0728a5512d1e7ULL;
};

template<class ContainerAllocator>
struct DataType< ::TestNode::PrintPersonResponse_<ContainerAllocator> > {
  static const char* value() 
  {
    return "TestNode/PrintPersonResponse";
  }

  static const char* value(const  ::TestNode::PrintPersonResponse_<ContainerAllocator> &) { return value(); } 
};

template<class ContainerAllocator>
struct Definition< ::TestNode::PrintPersonResponse_<ContainerAllocator> > {
  static const char* value() 
  {
    return "TestNode/Person result\n\
\n\
\n\
================================================================================\n\
MSG: TestNode/Person\n\
string name\n\
int32 age\n\
float32 grade\n\
\n\
";
  }

  static const char* value(const  ::TestNode::PrintPersonResponse_<ContainerAllocator> &) { return value(); } 
};

} // namespace message_traits
} // namespace ros

namespace ros
{
namespace serialization
{

template<class ContainerAllocator> struct Serializer< ::TestNode::PrintPersonRequest_<ContainerAllocator> >
{
  template<typename Stream, typename T> inline static void allInOne(Stream& stream, T m)
  {
    stream.next(m.person);
  }

  ROS_DECLARE_ALLINONE_SERIALIZER;
}; // struct PrintPersonRequest_
} // namespace serialization
} // namespace ros


namespace ros
{
namespace serialization
{

template<class ContainerAllocator> struct Serializer< ::TestNode::PrintPersonResponse_<ContainerAllocator> >
{
  template<typename Stream, typename T> inline static void allInOne(Stream& stream, T m)
  {
    stream.next(m.result);
  }

  ROS_DECLARE_ALLINONE_SERIALIZER;
}; // struct PrintPersonResponse_
} // namespace serialization
} // namespace ros

namespace ros
{
namespace service_traits
{
template<>
struct MD5Sum<TestNode::PrintPerson> {
  static const char* value() 
  {
    return "ac755e5677e0aa919c7dec90107c86b2";
  }

  static const char* value(const TestNode::PrintPerson&) { return value(); } 
};

template<>
struct DataType<TestNode::PrintPerson> {
  static const char* value() 
  {
    return "TestNode/PrintPerson";
  }

  static const char* value(const TestNode::PrintPerson&) { return value(); } 
};

template<class ContainerAllocator>
struct MD5Sum<TestNode::PrintPersonRequest_<ContainerAllocator> > {
  static const char* value() 
  {
    return "ac755e5677e0aa919c7dec90107c86b2";
  }

  static const char* value(const TestNode::PrintPersonRequest_<ContainerAllocator> &) { return value(); } 
};

template<class ContainerAllocator>
struct DataType<TestNode::PrintPersonRequest_<ContainerAllocator> > {
  static const char* value() 
  {
    return "TestNode/PrintPerson";
  }

  static const char* value(const TestNode::PrintPersonRequest_<ContainerAllocator> &) { return value(); } 
};

template<class ContainerAllocator>
struct MD5Sum<TestNode::PrintPersonResponse_<ContainerAllocator> > {
  static const char* value() 
  {
    return "ac755e5677e0aa919c7dec90107c86b2";
  }

  static const char* value(const TestNode::PrintPersonResponse_<ContainerAllocator> &) { return value(); } 
};

template<class ContainerAllocator>
struct DataType<TestNode::PrintPersonResponse_<ContainerAllocator> > {
  static const char* value() 
  {
    return "TestNode/PrintPerson";
  }

  static const char* value(const TestNode::PrintPersonResponse_<ContainerAllocator> &) { return value(); } 
};

} // namespace service_traits
} // namespace ros

#endif // TESTNODE_SERVICE_PRINTPERSON_H

